import gi
gi.require_version('Gtk', '4.0')
# gi.require_version('Adw', '1')
from gi.repository import Gtk, Gio, GLib, Gdk
class MainWindow(Gtk.ApplicationWindow):
    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        # Things will go here

        # Set some window parameters
        self.set_default_size(1200, 800)
        self.set_title('Redis Tool')

        # add boxes.
        box0 = Gtk.Box(orientation=Gtk.Orientation.HORIZONTAL)

        box1 = Gtk.Box(orientation=Gtk.Orientation.VERTICAL)
        box1.set_margin_top(30)
        box1.set_margin_start(30)
        box1.set_margin_end(30)
        box1.set_spacing(10)

        self.lbl_title = Gtk.Label(label='Enable TLS connection?')
        self.lbl_title.set_halign(Gtk.Align.START)
        box1.append(self.lbl_title)

        switch = Gtk.Switch()
        switch.set_halign(Gtk.Align.START)
        # switch.set_active(True)  # Let's default it to on
        # self.switch.connect('state-set', self.switch_switched)  # Let's trigger a function
        box1.append(switch)

        label1 = Gtk.Label(label='Host')
        label1.set_halign(Gtk.Align.START)
        box1.append(label1)

        self.entry_field1 = Gtk.Entry()
        self.entry_field1.set_max_width_chars(60)
        self.entry_field1.set_halign(Gtk.Align.START)
        box1.append(self.entry_field1)

        ###
        self.open_dialog_ca_cert = Gtk.FileChooserNative.new(title='Choose a CA Cert',
                                                parent=self, action=Gtk.FileChooserAction.OPEN)
        self.open_dialog_ca_cert.connect('response', self.open_response_ca_cert)

        label_filepicker = Gtk.Label(label='Choose a CA Certificate')
        label_filepicker.set_halign(Gtk.Align.START)
        box1.append(label_filepicker)

        btn_open_ca_cert = Gtk.Button(label='Select')
        btn_open_ca_cert.set_icon_name('document-open-symbolic')
        btn_open_ca_cert.connect('clicked', self.show_open_dialog_ca_cert)
        btn_open_ca_cert.set_halign(Gtk.Align.START)
        box1.append(btn_open_ca_cert)

        ###
        self.open_dialog_host_cert = Gtk.FileChooserNative.new(title='Choose a Host Cert',
                                                             parent=self, action=Gtk.FileChooserAction.OPEN)
        self.open_dialog_host_cert.connect('response', self.open_response_host_cert)

        label_filepicker2 = Gtk.Label(label='Choose a Host Certificate')
        label_filepicker2.set_halign(Gtk.Align.START)
        box1.append(label_filepicker2)

        btn_open_host_cert = Gtk.Button(label='Select')
        btn_open_host_cert.set_icon_name('document-open-symbolic')
        btn_open_host_cert.connect('clicked', self.show_open_dialog_host_cert)
        btn_open_host_cert.set_halign(Gtk.Align.START)
        box1.append(btn_open_host_cert)

        ###
        self.open_dialog_host_key = Gtk.FileChooserNative.new(title='Choose a Host key',
                                                               parent=self, action=Gtk.FileChooserAction.OPEN)
        self.open_dialog_host_key.connect('response', self.open_response_host_key)

        label_filepicker3 = Gtk.Label(label='Choose a Host key')
        label_filepicker3.set_halign(Gtk.Align.START)
        box1.append(label_filepicker3)

        btn_open_host_key = Gtk.Button(label='Select')
        btn_open_host_key.set_icon_name('document-open-symbolic')
        btn_open_host_key.connect('clicked', self.show_open_dialog_host_key)
        btn_open_host_key.set_halign(Gtk.Align.START)
        box1.append(btn_open_host_key)

        btn_restart = Gtk.Button(label='Restart Redis service')
        btn_restart.connect('clicked', self.respond_to_restart)
        btn_restart.set_halign(Gtk.Align.START)
        box1.append(btn_restart)

        box2 = Gtk.Box(orientation=Gtk.Orientation.VERTICAL)
        box2.set_margin_top(30)
        box2.set_margin_start(30)
        box2.set_margin_end(30)
        box2.set_spacing(10)

        lbl_redis_output  = Gtk.Label(label='Redis output from redis-cli')
        lbl_redis_output .set_halign(Gtk.Align.START)
        box2.append(lbl_redis_output)

        btn_get_keys = Gtk.Button(label='Get keys')
        btn_get_keys.connect('clicked', self.get_output_keys)
        btn_get_keys.set_halign(Gtk.Align.START)
        box2.append(btn_get_keys)

        self.textview_redis_output = Gtk.TextView()
        self.textview_redis_output.set_halign(Gtk.Align.START)
        box2.append(self.textview_redis_output)

        box0.append(box1)
        box0.append(box2)

        #
        # ##### CSS ###################################################################################################
        # css_provider = Gtk.CssProvider()
        # css_provider.load_from_path('/home/scott/ws/py/pygo/pygo_test1/styles/style1.css')
        # Gtk.StyleContext.add_provider_for_display(Gdk.Display.get_default(), css_provider,
        #                                           Gtk.STYLE_PROVIDER_PRIORITY_APPLICATION)
        #
        # # self.lbl_title.set_css_classes(['title'])
        #
        # # btn_submit.set_css_classes(['button-strong'])
        # # btn_open_ca_cert.set_css_classes(['button-strong'])
        #
        # # self.set_css_classes(['bg-green'])

        self.set_child(box0)

    def show_open_dialog_ca_cert(self, button):
        self.open_dialog_ca_cert.show()

    def show_open_dialog_host_cert(self, button):
        self.open_dialog_host_cert.show()

    def show_open_dialog_host_key(self, button):
        self.open_dialog_host_key.show()

    def open_response_ca_cert(self, dialog, response):
        if response == Gtk.ResponseType.ACCEPT:
            file = dialog.get_file()
            filename = file.get_path()
            print(filename)  # Here you could handle opening or saving the file

    def open_response_host_cert(self, dialog, response):
        if response == Gtk.ResponseType.ACCEPT:
            file = dialog.get_file()
            filename = file.get_path()
            print(filename)  # Here you could handle opening or saving the file

    def open_response_host_key(self, dialog, response):
        if response == Gtk.ResponseType.ACCEPT:
            file = dialog.get_file()
            filename = file.get_path()
            print(filename)  # Here you could handle opening or saving the file

    def respond_to_restart(self, button):
        pass
        # print('submitted')
        # print('Name: ' + self.entry_field1.get_text())
        # self.close()

    def get_output_keys(self, widget):
        self.textview_redis_output.set_editable(True)
        text_buffer = self.textview_redis_output.get_buffer()
        text_buffer.set_text("Test keys here")
        # widget.get_active()
